#include <iostream>
using namespace std;

template<typename T, typename U> T convert(U u) {
	cout << "template<T>: ";
	return static_cast<T>(u);
};

//	and specializations ...

template<> int convert<int>(double u) {
	cout << "template<int>: ";
	return static_cast<int>(u);
};

template<> double convert<double>(double u) {
	cout << "template<double>: ";
	return static_cast<double>(u);
};

//	In any case we have to explicitly use the first template argument (T)
//	since it cannot be guessed from the function parameter list

int main () {

	cout.setf(ios::fixed, ios::floatfield);
	cout.precision(1);

	cout << "convert<double>(65) = " << convert<double>(65) << endl;
	cout << "convert<int>(6.5) = " << convert<int>(6.5) << endl;
	cout << "convert<double>(6.5) = " << convert<double>(6.5) << endl;
	cout << "convert<char, int>(65) = " << convert<char, int>(65) << endl;
//	int j = convert(i);	//	ERROR! cannot guess T

	return 0;
}

